package com.example.afrishop_v3.controllers;

import com.example.afrishop_v3.base.Result;
import com.google.gson.Gson;
import com.stripe.Stripe;
import com.stripe.exception.StripeException;
import com.stripe.model.Customer;
import com.stripe.model.PaymentIntent;
import com.stripe.model.PaymentMethod;
import com.stripe.model.checkout.Session;
import com.stripe.param.PaymentIntentCreateParams;
import com.stripe.param.checkout.SessionCreateParams;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

/**
 * @Auther: wudepeng
 * @Date: 2021/01/04
 * @Description:Stripe支付
 */
@RestController
@RequestMapping("/stripe")
public class StripeController {

    private static Logger logger = LoggerFactory.getLogger(StripeController.class);

    @Value("${stripe.secret_key}")
    private String SECRET_KEY;

    @Value("${stripe.public_key}")
    private String PUBLIC_KEY;

    @Value("${stripe.success_url}")
    private String SUCCESS_URL;

    @Value("${stripe.cancel_url}")
    private String CANCEL_URL;

    @PostMapping("/payment")
    public Result payment(@RequestParam Map<String, Object> paramMap) {

        return new Result();
    }

   /* @PostMapping("/payment")
    public Result payment(@RequestParam Map<String, Object> paramMap) {

        Map<String, String> resultMap = new HashMap<>();
        try {
            Stripe.apiKey = SECRET_KEY;
            Map<String, Object> params = new HashMap<String, Object>();
            ArrayList<String> paymentMethodTypes = new ArrayList<>();
            paymentMethodTypes.add("card");
            params.put("payment_method_types", paymentMethodTypes);
            ArrayList<HashMap<String, Object>> lineItems = new ArrayList<>();
            HashMap<String, Object> lineItem = new HashMap<String, Object>();
            lineItem.put("name", "胡鹏飞测试商品");
            lineItem.put("description", "这是一个测试单描述");
            lineItem.put("amount", 500); // 支付金额
            lineItem.put("currency", "usd"); //支付币种
            lineItem.put("quantity", 1);
            lineItems.add(lineItem);
            params.put("line_items", lineItems);
            //TODO 必须使用https 返回的回调地址
            params.put("client_reference_id", paramMap.get("orderId"));//业务系统唯一标识 即订单唯一编号
            params.put("success_url", SUCCESS_URL);// 支付成功跳转页面
            params.put("cancel_url", CANCEL_URL);// 支付失败跳转页面
            Session session = Session.create(params);
            String sessionId = session.getId();
            logger.info("sessionId :{}", session.getId());
            resultMap.put("sessionId", sessionId);
        } catch (StripeException e) {
            e.printStackTrace();
        }
        return new Result(resultMap);

    }*/

    @GetMapping("/getPublicKey")
    public Result getPublicKey() {

        return new Result(PUBLIC_KEY);
    }


}
